Bug 1304 - missing files with linux CIFS client, smbclient OK
missing files with linux CIFS client, smbclient OK
Status: RESOLVED FIXED
Product: CifsVFS
Classification: Unclassified
Component: kernel fs
2.4
All Linux
: P3 normal
: ---
Assigned To: Steve French
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2004-04-29 08:15 UTC by Joerg Behrend
Modified: 2005-03-07 20:59 UTC (History)
0 users

See Also:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Joerg Behrend 2004-04-29 08:15:37 UTC
In a directory with approximately 300 files, several (dozens) files
are missing if the directory is mounted with /sbin/mount.cifs via the
Linux CIFS module kernel/fs/cifs/cifs.o.

We are using a Redhat Linux Workstation Version 3 with  kernel 
2.4.21-9.0.3.EL
including cifs-1.0.2b.

The problem occurs on a Samba server 3.0.2a running Solaris 2.8
as well as using the precompiled Redhat Linux Samba server.
If the samba client is changed from CIFS kernel module to smbclient,
all files are listed as expected.


As far as we can see, the string "get_lanman2_dir_entry: out of space"
is printed in the samba server debug log (only one time using the CIFS
module leading to missing files, several times using smbclient
where everything is OK).

Thanks in advance for a reply.

Joerg Behrend
University of Cologne
Institute of Mathematics
Comment 1 Steve French 2004-07-30 09:31:59 UTC
Can you try 1.20c version of cifs? 
 
http://hostopia.samba.org/samba/ftp/cifs-cvs/cifs-1.20c-2.4.tar.gz 
Comment 2 Joerg Behrend 2004-08-03 08:49:13 UTC
(In reply to comment #1)
> Can you try 1.20c version of cifs? 
>  
> http://hostopia.samba.org/samba/ftp/cifs-cvs/cifs-1.20c-2.4.tar.gz 

Using the new module, all files in the directory  are available.

An advantage of the smbfs module (compared to cifs) is still that the connection
is reopened if the remote smbd server process is killed and started again. 

It would be fine to have such a fault tolerance also with the cifs module. With
this module, the connection is lost after the smbd process disappeared. To
reopen it, all client processes using the connection have to be killed, then the
smb share can be unmounted and remounted again. 
Comment 3 Steve French 2005-03-07 20:59:46 UTC
Note that cifs vfs also reconnects (and unlike smbfs, cifs vfs keeps and resets 
state properly except for byte range locks which neither preserves yet).